/*       SOCKET              Ignacio  Merino  Lagunilla                       */

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <sys/time.h>

#include "global.hpp"
#include "monitor.hpp"

//#define 	DEBUG


void salir(void)
{
#ifdef DEBUG
	printf("Fin de la ejecucion del programa\n");
	if(fichero == CIERTO) fprintf(accion , "Fin de la ejecucion del programa\n");
#endif
	close(mon->di_sock());
	ventana->liberar();
	if(mon != NULL) delete(mon);
	if(ventana != NULL) delete(ventana);
	if(fichero == CIERTO) fclose(accion);
	exit(20);
}

void monitor::enviar_msg(int socket)
{
 fd_set test;
 int escritos = 0 , n = 0 , veces = 0;
 struct timeval espera;

	while(escritos < MAX_MSG)
	{
		FD_ZERO(&test);
		FD_SET(socket , &test);
		espera.tv_sec = 0;
		espera.tv_usec = veces * 1000;
		select(socket+1 , NULL , SOCKET &test , NULL , &espera);
		if(FD_ISSET(socket , &test))
		{
			n = write(socket , &msg_sale[escritos] , MAX_MSG - escritos);
			if(n >= 0) escritos+=n;
			else
			{
				printf("\aERROR: Error en el envio de un mensaje al servidor.\nMejor me suicido.\n");
				if(fichero == CIERTO) fprintf(accion , "ERROR: Error en el envio de un mensaje al servidor.\nMejor me suicido.\n");
				salir();
			}
		}
		if(veces++ == 400)
		{
			printf("\aERROR: No puedo enviar mensajes al servidor.\nMejor me suicido.\n");
			if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo enviar mensajes al servidor.\nMejor me suicido.\n");
			salir();
		}
	}
}

void monitor::recibir_msg(int socket , char codigo[3] , int opc)
{
 char cod[4] = { '\0','\0','\0','\0' };
 int leidos , n , veces1 = 0 , veces2 = 0;
 fd_set test;
 struct timeval espera;

	if(opc > 100) opc = 100;
	while(strcmp(cod , codigo) != 0)
 	{
		FD_ZERO(&test);
		FD_SET(socket , &test);
		espera.tv_sec = 0;
		espera.tv_usec = veces2 * 1000;
		select(socket+1 , SOCKET &test , NULL , NULL , &espera);
		if(FD_ISSET(socket , &test))
		{
			leidos = 0; veces1 = 0;
			while(leidos < MAX_MSG)
			{
				FD_ZERO(&test);
				FD_SET(socket , &test);
				espera.tv_sec = 0;
				espera.tv_usec = veces1 * 1000;
				select(socket+1 , SOCKET &test , NULL , NULL , &espera);
				if(FD_ISSET(socket , &test))
				{
					n = read(socket , &msg_entra[leidos] , MAX_MSG - leidos);
					if(n >= 0) leidos+=n;
					else
					{
						printf("\aERROR: Al recivir mensajes del servidor.\nMejor me suicido.\n");
						if(fichero == CIERTO) fprintf(accion , "ERROR: Al recivir mensajes del servidor.\nMejor me suicido.\n");
						conectado = FALSO; salir();
					}
				}
				if(veces1++ == 400)
				{
					printf("\aERROR: No puedo recibir mensajes del servidor.\nMejor me suicido.\n");
					if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo recibir mensajes del servidor.\nMejor me suicido.\n");
					salir();
				}
			}
#ifdef DEBUG
			printf("Recibo el mensaje '%s'\n" , msg_entra);
			if(fichero == CIERTO) fprintf(accion , "Recibo el mensaje '%s'\n" , msg_entra);
#endif
			veces2 = 0;
			strncpy(cod , msg_entra , 3);
			if( strcmp(cod , codigo) != 0 || opc)
			{
				if(strcmp(cod , "MPY") == 0) activo = FALSO;
				else if( strcmp(cod , "MCY") == 0) { activo = CIERTO; ventana->redibujar(1); }
				else if( strcmp(cod , "MFR") == 0) ventana->dibujar_recta();
				else if( strcmp(cod , "MFP") == 0) ventana->dibujar_poligono();
				else if( strcmp(cod , "MFS") == 0) ventana->dibujar_sector();
				else if( strcmp(cod , "MFC") == 0) ventana->dibujar_circulo();
				else if( strcmp(cod , "MFT") == 0) ventana->dibujar_texto();
				else if( strcmp(cod , "MFU") == 0) ventana->dibujar_punto();
				else if( strcmp(cod , "MFY") == 0) salir();
				else
				{
					printf("\aERROR: No entiendo el mensaje '%s'.\n" , msg_entra);
					if(fichero == CIERTO) fprintf(accion , "ERROR: No entiendo el mensaje '%s'.\n" , msg_entra);
				}
			}
		}
		if(veces2++ == 400)
		{
			printf("\aERROR: No recibo mensajes del servidor.\nMejor me suicido.\n");
			if(fichero == CIERTO) fprintf(accion , "ERROR: No recibo mensajes del servidor.\nMejor me suicido.\n");
			conectado = FALSO; salir();
		}
		if(opc == 1) return;
		if(opc > 1) --opc;
	}
}
