/******************************************************************************\
*                                                                              *
*       ROBOT               Ignacio  Merino  Lagunilla                         *
*                                                                              *
*       Funciones para comunicar el mundo con los robots mediante sockets.     *
*                                                                              *
*       22/febrero/1995                                                        *
\******************************************************************************/

#ifndef _ROBOT_
#define _ROBOT_

#include <stdio.h>
#include "sensor.hpp"

class robot{
	private:
		int sock;							// socket
		int accesible;
		char nombre[6];					// nombre
		punto_car pos;						// posicion x,y
		punto_car ult;						// posicion ultima
		float angulo;						// orientacion
		float ult_angulo;					// orientacion
		float v1 , v2;						// velocidades en ruedas
		int radio , ruedas;					// radio y distancia entre ruedas
		unsigned char color , rastro , sentido;	// colores
		int dibu_sen;						// dibujar sensores
		int dibu_rastro;					// dibujar rastro
		int activo;						// si esta activo o no
		sensor *ini_s,*fin_s;				// sensores
		robot *sig;
		robot *ant;
	public:
		robot(void);
		~robot(void);
		inline int di_sock(void) { return(sock); }
		inline int di_accesible(void) { return(accesible); }
		inline int* di_accesible2(void) { return(&accesible); }
		inline char* di_nombre(void) { return(nombre); }
		inline punto_car* di_pos(void) { return(&pos); }
		inline float di_angulo(void) { return(angulo); }
		inline robot* di_ant(void) { return(ant); }
		inline robot* di_sig(void) { return(sig); }
		inline void fijar_sock(int s) { sock = s; }
		inline unsigned char di_rastro(void) { return(rastro); }
		inline int di_dibu_sen(void) { return(dibu_sen); }
		int crear_primero(void);
		int crear(void);
		void destruir(int cerrar , int dibujar);
		int aceptar_nuevos(void);
		int obtener_datos(void);
		void responder_peticiones(void);
		int escribir_lista(char *fich , int copia);
		void terminar(void);
		void dibujar_mapa(void);
		void borrar_mapa(void);
		void dibujar_pan(void);
		void borrar_pan(void);
		int comprobar_datos(void);
		int comprobar(int x , int y);
		void enviar_robots(int socket);
		void enviar_robot(int socket);
		void mover(void);
		char* di_datos(void);
		void parar_robots(void);
		void continuar_robots(void);
};

#endif
