/*       SOCKET              Ignacio  Merino  Lagunilla                       */

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <sys/time.h>

#include "global.hpp"

//#define 	DEBUG


void comprobar_procesos(void)
{
 monitor *des_m , *mon = ini_m->di_sig();
 robot *des_r , *rob = ini_r->di_sig();

#ifdef DEBUG
	printf("Comprobando conexiones ...\n");
	if(fichero == CIERTO) fprintf(accion , "Comprobando conexiones ...\n");
#endif
	while(mon != NULL)
	{
 		if(mon->di_accesible() == FALSO)
		{
			printf("\aERROR: El proceso monitor %d es inaccesible; se le elimina.\n" , mon->di_sock());
			if(fichero == CIERTO) fprintf(accion , "ERROR: El proceso monitor %d es inaccesible; se le elimina.\n" , mon->di_sock());
			des_m = mon; mon = mon->di_ant(); des_m->destruir(1);
			ventana->redibujar(1);
		}
		mon = mon->di_sig();
	}
	while(rob != NULL)
	{
 		if(rob->di_accesible() == FALSO)
		{
			printf("\aERROR: El proceso robot '%s' es inaccesible; se le elimina.\n" , rob->di_nombre());
			if(fichero == CIERTO) fprintf(accion , "ERROR: El proceso robot '%s' es inaccesible; se le elimina.\n" , rob->di_nombre());
			des_r = rob; rob = rob->di_ant(); des_r->destruir(1 , 1);
			ventana->redibujar(1);
		}
		rob = rob->di_sig();
	}
	fallo = FALSO;
}

int enviar_msg(int socket , int *accesible)
{
 fd_set test;
 int escritos = 0 , n = 0 , veces = 0;
 struct timeval espera;

 	if(*accesible == CIERTO)
	{
		while(escritos < MAX_MSG)
		{
			FD_ZERO(&test);
			FD_SET(socket , &test);
			espera.tv_sec = 0;
			espera.tv_usec = veces * 1000;
			select(socket+1 , NULL , SOCKET &test , NULL , &espera);
			if(FD_ISSET(socket , &test))
			{
				n = write(socket , &msg_sale[escritos] , MAX_MSG - escritos);
				if(n >= 0) escritos+=n;
				else
				{
					printf("\aERROR: Error al enviar un mensaje al proceso %d.\n" , socket);
					if(fichero == CIERTO) fprintf(accion , "ERROR: Error al enviar un mensaje al proceso %d.\n" , socket);
					*accesible = FALSO; fallo = CIERTO;
					return(-1);
				}
			}
			if(veces++ == 350)
			{
				printf("\aERROR: No puedo enviar mensajes al proceso %d.\n" , socket);
				if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo enviar mensajes al proceso %d.\n" , socket);
				*accesible = FALSO; fallo = CIERTO;
				return(-2);
			}
		}
#ifdef DEBUG
		printf("Envio el mensaje '%s'\n" , msg_sale);
		if(fichero == CIERTO) fprintf(accion , "Envio el mensaje '%s'\n" , msg_sale);
#endif
	}
	return(0);
}

int recibir_msg(int socket , int *accesible)
{
 fd_set test;
 int leidos = 0 , n = 0 , veces = 0;
 struct timeval espera;

	if(*accesible == CIERTO)
	{
		while(leidos < MAX_MSG)
		{
			FD_ZERO(&test);
			FD_SET(socket , &test);
			espera.tv_sec = 0;
			espera.tv_usec = veces * 1000;
			select(socket+1 , SOCKET &test , NULL, NULL , &espera);
			if(FD_ISSET(socket , &test))
			{
				n = read(socket , &msg_entra[leidos] , MAX_MSG - leidos);
				if(n >= 0) leidos+=n;
				else
				{
					printf("\aERROR: Error al recibir un mensaje del proceso %d.\n" , socket);
					if(fichero == CIERTO) fprintf(accion , "ERROR: Error al recibir un mensaje del proceso %d.\n" , socket);
					*accesible = FALSO; fallo = CIERTO;
					return(-1);
				}
			}
			if(veces++ == 350)
			{
				printf("\aERROR: No puedo recivir mensajes de algun proceso.\n");
				if(fichero == CIERTO) fprintf(accion , "ERROR: No puedo recivir mensajes de algun proceso.\n");
				*accesible = FALSO; fallo = CIERTO;
				return(-2);
			}
		}
#ifdef DEBUG
		printf("Recibo el mensaje '%s'\n" , msg_entra);
		if(fichero == CIERTO) fprintf(accion , "Recibo el mensaje '%s'\n" , msg_entra);
#endif
	}
	return(0);
}
