/*       VENTANA             Ignacio  Merino  Lagunilla                       */

#include <string.h>

#include "global.hpp"

//#define 	DEBUG


void parar(void)
{
	if(activo == CIERTO)
	{
		ini_r->di_sig()->parar_robots();
		ini_m->di_sig()->parar_monitores();
		activo = FALSO;
#ifdef DEBUG
		printf("Paro a todos los procesos\n");
		if (fichero == CIERTO) fprintf(accion , "Paro a todos los procesos\n");
#endif
	}
	else
	{
		ini_r->di_sig()->continuar_robots();
		ini_m->di_sig()->continuar_monitores();
		activo = CIERTO;
#ifdef DEBUG
		printf("Mando continuar a todos los procesos\n");
		if (fichero == CIERTO) fprintf(accion , "Mando continuar a todos los procesos\n");
#endif
	}
}

void fijar_pasos_dibujo(void)
{
	printf("Cada cuantos pasos se dibuja: ");
	scanf("%d" , &pasos_dibujo);
#ifdef DEBUG
	printf("Se dibuja cada %d pasos\n" , pasos_dibujo);
	if (fichero == CIERTO) fprintf(accion , "Se dibuja cada %d pasos\n" , pasos_dibujo);
#endif
}

void ventana_info::crear(void)
{
 int screen;
 XSizeHints hint;
 unsigned long foreground , background;

	display = XOpenDisplay("");
	screen = DefaultScreen(display);
	background = WhitePixel(display , screen);
	foreground = BlackPixel(display , screen);
	hint.x = 0;
	hint.y = 0;
	hint.width = 550;
	hint.height = 310;
	hint.flags = PPosition | PSize;
	window = XCreateSimpleWindow(display , DefaultRootWindow(display),
		hint.x , hint.y , hint.width , hint.height , 7 ,
		foreground , background);
	XSetStandardProperties(display , window , "SimDAI  V 1.0  -  Mundo",
		"SimDAI" , None , NULL , 0 , &hint);
	gc = XCreateGC(display , window , 0 , 0);
	XSetBackground(display , gc , background);
	XSetForeground(display , gc , foreground);
	XSelectInput(display , window , (KeyPressMask | ExposureMask));
	XMapRaised(display , window);
	XFlush(display);
#ifdef DEBUG
	printf("Creo la ventana de informacion\n");
	if(fichero == CIERTO) fprintf(accion , "Creo la ventana de informacion\n");
#endif
}

void ventana_info::liberar(void)
{
	XFreeGC(display , gc);
	XDestroyWindow(display , window);
	XCloseDisplay(display);
	XFlush(display);
#ifdef DEBUG
	printf("Libero la ventana de informacion\n");
	if(fichero == CIERTO) fprintf(accion , "Libero la ventana de informacion\n");
#endif
}

void ventana_info::redibujar(int borrar)
{
 char linea[100];
 int y = 30;
 robot *rob = ini_r->di_sig();
 monitor *mon = ini_m->di_sig();

#ifdef DEBUG
	printf("Dibujo la ventana de informacion\n");
	if(fichero == CIERTO) fprintf(accion , "Dibujo la ventana de informacion\n");
#endif
	if(borrar != 0) XClearWindow(display , window);
	sprintf(linea , "Mundo     pasos dibujo = %d     %s" , pasos_dibujo , (activo == CIERTO) ? "Activo" : "Parado");
	XDrawImageString(display , window , gc , 20 , y , linea , strlen(linea)); y+=30;
	while(mon != NULL)
	{
		strcpy(linea , mon->di_datos());
		XDrawImageString(display , window , gc , 20 , y , linea , strlen(linea)); y+=30;
		mon = mon->di_sig();
	}
	XFlush(display);
#ifdef DEBUG
	printf("Dibujo los procesos monitor en la ventana de informacion\n");
	if(fichero == CIERTO) fprintf(accion , "Dibujo los procesos monitor en la ventana de informacion\n");
#endif
	while(rob != NULL)
	{
		strcpy(linea , rob->di_datos());
		XDrawImageString(display , window , gc , 20 , y , linea , strlen(linea)); y+=30;
		rob = rob->di_sig();
	}
#ifdef DEBUG
	printf("Dibujo los procesos robot en la ventana de informacion\n");
	if(fichero == CIERTO) fprintf(accion , "Dibujo los procesos robot en la ventana de informacion\n");
#endif
	XFlush(display);
}

int eventos(Display *display , XEvent *evento , char *nada)
{
 KeySym key;
 char buffer[8];
 int teclas;

	XNextEvent(display , evento);
	switch(evento->type)
	{
	   case Expose:
		if(evento->xexpose.count==0)
		{
#ifdef DEBUG
			printf("Nuevo evento de esposicion\n");
			if (fichero == CIERTO) fprintf(accion , "Nuevo evento de esposicion\n");
#endif
			ventana->redibujar(0);
		}
		break;

	   case MappingNotify:
		XRefreshKeyboardMapping((struct XMappingEvent *) evento);
		break;

	   case KeyPress:
		teclas = XLookupString((struct XKeyEvent *) evento , buffer , 8 , &key , 0);
		if (teclas == 1 && buffer[0] == 'q') final = CIERTO;
		else if (teclas == 1 && buffer[0] == 's') parar();
		else if (teclas == 1 && buffer[0] == 'g') figuras->escribir_figuras(f_figcop , 1);
		else if (teclas == 1 && buffer[0] == 'm') mapa->escribir(f_mapcop , 1);
		else if (teclas == 1 && buffer[0] == 'r') ini_r->di_sig()->escribir_lista(f_robcop , 1);
		else if (teclas == 1 && buffer[0] == 'n') ini_m->di_sig()->escribir_lista(f_moncop , 1);
		else if (teclas == 1 && buffer[0] == 'd') fijar_pasos_dibujo();
		else if (teclas == 1 && buffer[0] == '+') { if(pasos_dibujo < 100) pasos_dibujo++; }
		else if (teclas == 1 && buffer[0] == '-') { if(pasos_dibujo > 0) pasos_dibujo--; }
		else if (teclas == 1 && buffer[0] == 'f') ventana->redibujar(1);
#ifdef DEBUG
		printf("Se ha pulsado la tecla '%c'\n" , buffer[0]);
		if (fichero == CIERTO) fprintf(accion , "Se ha pulsado la tecla '%c'\n" , buffer[0]);
#endif
		break;
	   default:
#ifdef DEBUG
	        printf("Nuevo evento no seleccionado\n");
	        if (fichero == CIERTO) fprintf(accion , "Nuevo evento no seleccionado\n");
#endif
		break;
	}
	return(0);
}

void ventana_info::comprobar_eventos(void)
{
	XCheckIfEvent(display , &evento , eventos , NULL);
}
