/*       VENTANA             Ignacio  Merino  Lagunilla                       */

#include <string.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/Box.h>

#include "global.hpp"

//#define 	DEBUG


Widget barra , dibujo , acerca , ayuda;
XtAppContext contexto;

void dibujar(Widget w , caddr_t dato , XEvent *evento, char *nada)
{
	ventana->redibujar();
}

void parar(Widget w , XtPointer dato , XtPointer nada)
{
	if(conectado == CIERTO) rob->parar();
}

void terminar(Widget w , XtPointer dato , XtPointer nada)
{
	if(conectado == CIERTO) rob->desconectar();
	acabar = final = CIERTO;
}

void conectar(Widget w,XtPointer dato,XtPointer nada)
{
	if(conectado == FALSO)
	{
		printf("Nombre del servidor: ");
		scanf("%s" , servidor);
		printf("Numero de puerto: ");
		scanf("%d" , &puerto_r);
		rob->conectar();
		if(conectado == CIERTO) ventana->redibujar();
#ifdef DEBUG
		printf("Me conecto al servidor '%s' %d\n" , servidor , conectado);
		if(fichero == CIERTO) fprintf(accion , "Me conecto al servidor '%s' %d\n" , servidor , conectado);
#endif
	}
}

void desconectar(Widget w , XtPointer dato , XtPointer nada)
{
	if(conectado == CIERTO) rob->desconectar();
}

void refrescar(Widget w , XtPointer dato , XtPointer nada)
{
	ventana->redibujar();
}

void mostrar_sensores(Widget w , XtPointer dato , XtPointer nada)
{
	rob->ver_sensores();
}

void ocultar_sensores(Widget w , XtPointer dato , XtPointer nada)
{
	rob->no_ver_sensores();
}

void mostrar_rastro(Widget w , XtPointer dato , XtPointer nada)
{
	rob->ver_rastro();
}

void ocultar_rastro(Widget w , XtPointer dato , XtPointer nada)
{
	rob->no_ver_rastro();
}

void enviar_mensaje(Widget w , XtPointer dato , XtPointer nada)
{
 char mens[45] , destino[6] , linea[100];
 robot_inf *aux = ini_ri;

	if(conectado == CIERTO)
	{
		printf("Mensaje: ");
		scanf("%s" , linea);
		strncpy(mens , linea , 44); mens[44] = '\0';
		printf("Destino: ");
		scanf("%s" , linea);
		strncpy(destino , linea , 5); destino[5] = '\0';
		while(aux != NULL && strcmp(destino , aux->di_nombre()) != 0) aux = aux->di_sig();
		if(aux != NULL)
		{
			sprintf(msg_sale , "REM%s %s" , destino , mens);
			rob->enviar_msg(rob->di_sock());
#ifdef DEBUG
			printf("Envio el mensaje '%s' al robot '%s'\n" , mens , destino);
			if(fichero == CIERTO) fprintf(accion , "Envio el mensaje '%s' al robot '%s'\n" , mens , destino);
#endif
		}
		else
		{
#ifdef DEBUG
			printf("No puedo enviar el mensaje '%s' al robot '%s'\n" , mens , destino);
			if(fichero == CIERTO) fprintf(accion , "No puedo enviar el mensaje '%s' al robot '%s'\n" , mens , destino);
#endif
		}
	}
}

void copia_mensajes(Widget w , XtPointer dato , XtPointer nada)
{
	rob->di_ini_m()->escribir(1);
}

void copia_robots(Widget w , XtPointer dato , XtPointer nada)
{
	ini_ri->escribir(1);
}

void ver_acerca(Widget w , XtPointer dato , XtPointer nada)
{
}

void ver_ayuda(Widget w , XtPointer dato , XtPointer nada)
{
}

void ventana_info::crear(void)
{
 char *nombre[] = { "SimDAI  V 1.0   -   Robot" , NULL };
 Widget aplicacion , shell , boton1 , boton2 , boton3 , boton4 , boton5 , menu1 , menu2 , menu3 , menu4 , menu5 , opcion;
 int i = 1;
 int screen;
 static char *recursos[] = {
	"*Box*background:				White",
	"*SimpleMenu*foreground:			SteelBlue",
	"*MenuButton.foreground:			Red",
	"*font:						*times*medium*18*iso8859-1",
	"*boton1.label:				Fin",
	"*boton2.label:				Conexion",
	"*boton3.label:				Opciones",
	"*boton4.label:				Mensajes",
	"*boton5.label:				Ayuda",
	"*SimpleMenu*SmeBSB*RowHeight:	25",
	"*SimpleMenu*SmeLine*height:		10",
	"*dibujo.width:				410",
	"*dibujo.height:				250",
	"*barra.width:					410",
	"*acerca.width:				200",
	"*acerca.height:				100",
	"*ayuda.width:					200",
	"*ayuda.height:				100",
	NULL
 };

	aplicacion = XtVaAppInitialize(&contexto , "XSimDAI.Rob" , NULL , 0 , &i , nombre , recursos , NULL);

	shell = XtVaCreateManagedWidget("shell" , boxWidgetClass , aplicacion , NULL);

	barra = XtVaCreateManagedWidget("barra" , boxWidgetClass , shell , NULL);

	boton1 = XtVaCreateManagedWidget("boton1" , menuButtonWidgetClass , barra , NULL);
	boton2 = XtVaCreateManagedWidget("boton2" , menuButtonWidgetClass , barra , NULL);
	boton3 = XtVaCreateManagedWidget("boton3" , menuButtonWidgetClass , barra , NULL);
	boton4 = XtVaCreateManagedWidget("boton4" , menuButtonWidgetClass , barra , NULL);
	boton5 = XtVaCreateManagedWidget("boton5" , menuButtonWidgetClass , barra , NULL);

	menu1 = XtCreatePopupShell("menu" , simpleMenuWidgetClass , boton1 , NULL,0);
	menu2 = XtCreatePopupShell("menu" , simpleMenuWidgetClass , boton2 , NULL,0);
	menu3 = XtCreatePopupShell("menu" , simpleMenuWidgetClass , boton3 , NULL,0);
	menu4 = XtCreatePopupShell("menu" , simpleMenuWidgetClass , boton4 , NULL,0);
	menu5 = XtCreatePopupShell("menu" , simpleMenuWidgetClass , boton5 , NULL,0);
#ifdef DEBUG
	printf("Creo los menus de la ventana\n");
	if(fichero == CIERTO) fprintf(accion , "Creo los menus de la ventana\n");
#endif

	opcion = XtCreateManagedWidget("Parar / Continuar" , smeBSBObjectClass , menu1 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , parar , (XtPointer) i);
	opcion = XtCreateManagedWidget("linea11" , smeLineObjectClass , menu1 , NULL , 0);
	opcion = XtCreateManagedWidget("Terminar" , smeBSBObjectClass , menu1 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , terminar , (XtPointer) i);

	opcion = XtCreateManagedWidget("Conectar" , smeBSBObjectClass , menu2 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , conectar , (XtPointer) i);
	opcion = XtCreateManagedWidget("Desconectar",smeBSBObjectClass,menu2,NULL,0);
	XtAddCallback(opcion , XtNcallback , desconectar , (XtPointer) i);

	opcion = XtCreateManagedWidget("Refrescar" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , refrescar , (XtPointer) i);
	opcion = XtCreateManagedWidget("linea31" , smeLineObjectClass , menu3 , NULL , 0);
	opcion = XtCreateManagedWidget("Mostrar sensores" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback, mostrar_sensores,(XtPointer) i);
	opcion = XtCreateManagedWidget("Ocultar sensores" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback, ocultar_sensores , (XtPointer) i);
	opcion = XtCreateManagedWidget("linea32" , smeLineObjectClass , menu3 , NULL , 0);
	opcion = XtCreateManagedWidget("Mostrar rastro" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback, mostrar_rastro , (XtPointer) i);
	opcion = XtCreateManagedWidget("Ocultar rastro" , smeBSBObjectClass , menu3 , NULL , 0);
	XtAddCallback(opcion , XtNcallback, ocultar_rastro , (XtPointer) i);

	opcion = XtCreateManagedWidget("Enviar mensaje" , smeBSBObjectClass , menu4 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , enviar_mensaje , (XtPointer) i);
	opcion = XtCreateManagedWidget("linea41" , smeLineObjectClass , menu4 , NULL , 0);
	opcion = XtCreateManagedWidget("Copia de mensajes" , smeBSBObjectClass , menu4 , NULL , 0);
	XtAddCallback(opcion , XtNcallback, copia_mensajes ,(XtPointer) i);
	opcion = XtCreateManagedWidget("Copia de robots" , smeBSBObjectClass , menu4 , NULL , 0);
	XtAddCallback(opcion , XtNcallback, copia_robots , (XtPointer) i);

	opcion = XtCreateManagedWidget("Acerca" , smeBSBObjectClass , menu5 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , ver_acerca , (XtPointer) i);
	opcion = XtCreateManagedWidget("Ayuda" , smeBSBObjectClass , menu5 , NULL , 0);
	XtAddCallback(opcion , XtNcallback , ver_ayuda , (XtPointer) i);
#ifdef DEBUG
	printf("Creo las opciones de los menus de la ventana\n");
	if(fichero == CIERTO) fprintf(accion , "Creo las opciones de los menus de la ventana\n");
#endif

	dibujo = XtCreateManagedWidget("dibujo" , simpleWidgetClass , shell , NULL , 0);
	display = XtDisplay(dibujo);
	screen = DefaultScreen(display);
	XtAddEventHandler(dibujo , ExposureMask , FALSE , dibujar , NULL);
	gc = XtGetGC(dibujo , 0 , 0);
	XSetForeground(display , gc , BlackPixel(display , screen) );
	XSetBackground(display , gc , WhitePixel(display , screen) );

	acerca = XtCreatePopupShell("acerca" , transientShellWidgetClass , shell , NULL , 0);

	ayuda = XtCreatePopupShell("ayuda" , transientShellWidgetClass , shell , NULL , 0);

	XtRealizeWidget(aplicacion);
	window = XtWindow(dibujo);
#ifdef DEBUG
	printf("Creo la ventana de informacion\n");
	if(fichero == CIERTO) fprintf(accion , "Creo la ventana de informacion\n");
#endif
}

void ventana_info::liberar(void)
{
	XtReleaseGC(dibujo , gc);
	XtRemoveEventHandler(dibujo , ExposureMask , FALSE , dibujar , NULL);
	XtCloseDisplay(display);
#ifdef DEBUG
	printf("Libero la ventana de informacion\n");
	if(fichero == CIERTO) fprintf(accion , "Libero la ventana de informacion\n");
#endif
}

void ventana_info::redibujar(void)
{
 char linea[100];
 int y = 30;
 sensor *aux = rob->di_ini_s();

	sprintf(linea , "Robot:       %10s     %s" , rob->di_nombre() , (rob->di_activo()) ? "Activo" : "Parado");
	XDrawImageString(display , window , gc , 20 , y , linea , strlen(linea)); y+=30;
	sprintf(linea , "Posicion     X =%5d     Y =%5d     sentido =%4d" , (int)rob->di_pos()->di_x() , (int)rob->di_pos()->di_y() , grados( rob->di_angulo() ));
	XDrawImageString( display , window , gc , 20 , y , linea , strlen(linea)); y+=30;
	while(aux != NULL)
	{
		strcpy(linea , aux->di_datos());
		XDrawImageString(display , window , gc , 50 , y , linea , strlen(linea)); y+=30;
		aux = aux->di_sig();
	}
	sprintf(linea , "Velodidad     V izq =%6.2f     V der =%6.2f" , rob->di_v1() , rob->di_v2());
	XDrawImageString(display , window , gc , 20 , y , linea , strlen(linea)); y+=30;
	sprintf(linea , "Numero de choques = %5d" , rob->di_choques());
	XDrawImageString(display , window , gc ,20 , y , linea , strlen(linea));
#ifdef DEBUG
	printf("Dibujo la ventana de informacion\n");
	if(fichero == CIERTO) fprintf(accion , "Dibujo la ventana de informacion\n");
#endif
	XFlush(display);
}

void ventana_info::comprobar_eventos(void)
{
	if (XtAppPending(contexto) != 0)
	{
		XtAppNextEvent(contexto , &evento);
		XtDispatchEvent(&evento);
	}
	else XFlush(display);
}
